<template>
    <div class="view" :class="{ 'show-cockpit': showCockpit }" @mousemove="showCockpit = true; restartCockpitHidingTimer()">
        <Stage id="center" :data="data" :single-stream-mode="singleStreamMode" :self-view="cockpit != null && cockpit.selfView === true" :singleStreamMode="singleStreamMode" :statisticsVisible="statisticsLoggerId != null" @onStageChangedParticipantName="changeParticipantName" @onStageChangedMeName="changeMeName"/>
        <div id="conference-name">
            <name :value="data.conference.name" @change="changeConferenceName($event)"/>
        </div>
        <Chat id="chat" v-show="chat" :messages="data.messages" @onChatMessage="onChatMessage"/>
        <Cockpit id="cockpit" ref="cockpit" @mouseenter="isCockpitHovered = true" @mouseleave="isCockpitHovered = false; restartCockpitHidingTimer()"
                 @onCockpitPrimaryMediaStream="onCockpitPrimaryMediaStream" @onCockpitSecondaryMediaStream="onCockpitSecondaryMediaStream"
                 :recording-on="!!data.conference.recording" :recording-url="data.conference.recordingURL" @onCockpitRecordingButtonClicked="onCockpitRecordingButtonClicked"
                 :single-stream-mode="singleStreamMode" @onCockpitSingleStreamModeButtonClicked="onCockpitSingleStreamModeButtonClicked"
                 :statistics-on="statisticsLoggerId != null" @onCockpitStatisticsButtonClicked="onCockpitStatisticsButtonClicked"
                 :chat-on="chat" @onCockpitChatButtonClicked="chat = !chat"/>
    </div>
</template>

<script setup>

    import { ref, shallowRef, reactive, onMounted, onUnmounted } from "vue";
    import { useRouter } from "vue-router";
    import { MindSDK, ConferenceLayout, SessionListener, SessionOptions, ParticipantRole } from "mind-sdk-web";
    import MindAPI from "./MindAPI";
    import Name from "./components/Name.vue";
    import Cockpit from "./components/Cockpit.vue";
    import Chat from "./components/Chat.vue";
    import Stage from "./components/Stage.vue";

    const PARTICIPANT_NAMES = [ "Zeus", "Hera", "Poseidon", "Ares", "Athena", "Apollo", "Artemis", "Hephaestus", "Aphrodite", "Hermes", "Dionysus", "Hades", "Hypnos", "Nike", "Janus", "Nemesis", "Iris", "Hecate", "Prometheus", "Cronus" ];

    const router = useRouter();

    const cockpit = ref(null);

    const statisticsLoggerId = shallowRef(null);
    const chat = ref(false);
    const singleStreamMode = ref(false);

    let data = reactive({
        conference: {
            id: null,
            name: null,
            recording: false,
            recordingURL: null,
            mediaStream: shallowRef(null),
            statistics: []
        },
        me: {
            id: null,
            name: null,
            primaryMediaStream: shallowRef(null),
            secondaryMediaStream: shallowRef(null),
            statistics: []
        },
        participants: [],
        messages: [],
    });

    let conference = null;
    let me = null;
    let session = null;

    const showCockpit = ref(true);
    let cockpitHidingTimeoutId = null;
    const isCockpitHovered = ref(false);

    let sessionListener = new class extends SessionListener {

        onConferenceNameChanged(conference) {
            SessionListener.prototype.onConferenceNameChanged(conference);
            data.conference.name = conference.getName();
        }

        onConferenceRecordingStarted(conference) {
            SessionListener.prototype.onConferenceRecordingStarted(conference);
            data.conference.recording = true;
        }

        onConferenceRecordingStopped(conference) {
            SessionListener.prototype.onConferenceRecordingStopped(conference);
            data.conference.recording = false;
        }

        onConferenceEnded(conference) {
            SessionListener.prototype.onConferenceEnded(conference);
            alert("The room has been destroyed");
            router.push("/");
        }

        onMeExpelled(me) {
            SessionListener.prototype.onMeExpelled(me);
            alert("You have been expelled from the room");
            router.push("/");
        }

        onMeNameChanged(me) {
            SessionListener.prototype.onMeNameChanged(me);
            data.me.name = me.getName();
        }

        onParticipantJoined(participant) {
            SessionListener.prototype.onParticipantJoined(participant);
            data.participants.push({
                id: participant.getId(),
                name: participant.getName(),
                primaryMediaStream: shallowRef(participant.isStreamingAudio() || participant.isStreamingVideo() ? participant.getMediaStream() : null),
                secondaryMediaStream: shallowRef(participant.isStreamingSecondaryAudio() || participant.isStreamingSecondaryVideo() ? participant.getSecondaryMediaStream() : null),
                statistics: []
            });
        }

        onParticipantExited(participant) {
            SessionListener.prototype.onParticipantExited(participant);
            data.participants.splice(data.participants.findIndex((p) => p.id === participant.getId()), 1);
        }

        onParticipantNameChanged(participant) {
            SessionListener.prototype.onParticipantNameChanged(participant);
            let p = data.participants.find((p) => p.id === participant.getId());
            p.name = participant.getName();
        }

        onParticipantMediaChanged(participant) {
            SessionListener.prototype.onParticipantMediaChanged(participant);
            let p = data.participants.find((p) => p.id === participant.getId());
            p.primaryMediaStream = participant.isStreamingAudio() || participant.isStreamingVideo() ? participant.getMediaStream() : null;
        }

        onParticipantSecondaryMediaChanged(participant) {
            SessionListener.prototype.onParticipantSecondaryMediaChanged(participant);
            let p = data.participants.find((p) => p.id === participant.getId());
            p.secondaryMediaStream = participant.isStreamingSecondaryAudio() || participant.isStreamingSecondaryVideo() ? participant.getSecondaryMediaStream() : null;
        }

        onMeReceivedMessageFromParticipant(me, message, participant) {
            SessionListener.prototype.onMeReceivedMessageFromParticipant(me, message, participant);
            data.messages.push({sentBy: participant.getName(), sentAt: Date.now(), text: message});
        }

    };

    const changeConferenceName = (name) => {
        conference.setName(name);
        data.conference.name = name;
    };

    const changeParticipantName = (participant, name) => {
        conference.getParticipantById(participant.id).setName(name);
        participant.name = name;
    };

    const changeMeName = (name) => {
        me.setName(name);
        data.me.name = name;
    };

    const onChatMessage = (message) => {
        data.messages.push({ sentBy: conference.me.getName(), sentAt: Date.now(), text: message });
        conference.me.sendMessageToAll(message);
    };

    const onCockpitRecordingButtonClicked = () => {
        if (conference.isRecording()) {
            conference.stopRecording();
            data.conference.recording = false;
        } else {
            conference.startRecording();
            data.conference.recording = true;
        }
    };

    const onCockpitSingleStreamModeButtonClicked = () => {
        singleStreamMode.value = !singleStreamMode.value;
    };

    const onCockpitPrimaryMediaStream = (primaryMediaStream) => {
        data.me.primaryMediaStream = primaryMediaStream;
        if (me != null) {
            me.setMediaStream(data.me.primaryMediaStream);
        }
    };

    const onCockpitSecondaryMediaStream = (secondaryMediaStream) => {
        data.me.secondaryMediaStream = secondaryMediaStream;
        if (me != null) {
            me.setSecondaryMediaStream(data.me.secondaryMediaStream);
        }
    };

    const onCockpitStatisticsButtonClicked = () => {
        if (statisticsLoggerId.value == null) {
            let updateStatistics = () => {
                for (let participant of data.participants.concat([data.me])) {
                    let primaryStatistics = {}, secondaryStatistics = {};
                    participant.statistics = [];
                    let p = conference.getParticipantById(participant.id);
                    if (p.isStreamingAudio()) {
                        let audioStatistics = p.getMediaStream().getAudioStatistics();
                        primaryStatistics.name = "primary";
                        primaryStatistics.volume = audioStatistics.getLevel();
                        primaryStatistics.sps = audioStatistics.getRate();
                    }
                    if (p.isStreamingVideo()) {
                        let videoStatistics = p.getMediaStream().getVideoStatistics();
                        primaryStatistics.name = "primary";
                        primaryStatistics.width = videoStatistics.getWidth();
                        primaryStatistics.height = videoStatistics.getHeight();
                        primaryStatistics.fps = videoStatistics.getRate();
                    }
                    if (p.isStreamingSecondaryAudio()) {
                        let audioStatistics = p.getSecondaryMediaStream().getAudioStatistics();
                        secondaryStatistics.name = "secondary";
                        secondaryStatistics.volume = audioStatistics.getLevel();
                        secondaryStatistics.sps = audioStatistics.getRate();
                    }
                    if (p.isStreamingSecondaryVideo()) {
                        let videoStatistics = p.getSecondaryMediaStream().getVideoStatistics();
                        secondaryStatistics.name = "secondary";
                        secondaryStatistics.width = videoStatistics.getWidth();
                        secondaryStatistics.height = videoStatistics.getHeight();
                        secondaryStatistics.fps = videoStatistics.getRate();
                    }
                    for (let statistics of [ primaryStatistics, secondaryStatistics ]) {
                        if (Object.keys(statistics).length > 0) {
                            participant.statistics.push(statistics);
                        }
                    }
                }
                if (singleStreamMode.value) {
                    let audioStatistics = conference.getMediaStream().getAudioStatistics();
                    let videoStatistics = conference.getMediaStream().getVideoStatistics();
                    data.conference.statistics = [{
                        volume: audioStatistics.getLevel(),
                        sps: audioStatistics.getRate(),
                        width: videoStatistics.getWidth(),
                        height: videoStatistics.getHeight(),
                        fps: videoStatistics.getRate()
                    }];
                } else {
                    data.conference.statistics = [];
                }
            };
            updateStatistics();
            statisticsLoggerId.value = setInterval(updateStatistics, 1000);
        } else {
            clearInterval(statisticsLoggerId.value);
            statisticsLoggerId.value = null;
            data.conference.statistics = [];
            for (let participant of data.participants) {
                participant.statistics = [];
            }
            data.me.statistics = [];
        }
    };

    const restartCockpitHidingTimer = () => {
        if (cockpitHidingTimeoutId != null) {
            clearTimeout(cockpitHidingTimeoutId);
            cockpitHidingTimeoutId = null;
        }
        if (data.conference.id && !isCockpitHovered.value) {
            cockpitHidingTimeoutId = setInterval(() => {
                if (!isCockpitHovered.value) {
                    document.body.click(); // FIXME: This is just a fast hacky way to collapse all `dropdowns` on the `cockpit`
                    showCockpit.value = false;
                    cockpit.value.collapsed = true;
                }
            }, 500);
        }
    };

    onMounted(() => {
        window.onpagehide = () => {
            if (session != null) {
                MindSDK.exit2(session);
                session = null;
            }
        };
        let conferenceURI = location.href.replace(/^(https?:\/\/[^/]+).*\/(#\/|\?)([^/]+)$/, "$1/00e1db72-c57d-478c-88be-3533d43c8b34/$3");
        let options = new SessionOptions();
        options.setUseVp9ForSendingVideo(true);
        MindAPI.createParticipant(conferenceURI, PARTICIPANT_NAMES[Math.floor(Math.random() * 20)], ConferenceLayout.MOSAIC, ParticipantRole.MODERATOR).then((token) => {
            return MindSDK.join(conferenceURI, token, options).then((conferenceSession) => {
                session = conferenceSession;
                session.setListener(sessionListener);
                conference = session.getConference();
                me = conference.getMe();
                console.log("Joined conference " + conference.getId() + " as participant " + me.getId() + "");
                data.conference.id = conference.getId();
                data.conference.name = conference.getName();
                data.conference.recording = conference.isRecording();
                data.conference.recordingURL = conference.getRecordingURL();
                data.conference.mediaStream = conference.getMediaStream();
                data.me.id = me.getId();
                data.me.name = me.getName();
                conference.getParticipants().forEach((participant) => sessionListener.onParticipantJoined(participant));
                cockpit.value.initialize();
                restartCockpitHidingTimer();
            });
        }).catch((error) => {
            alert(error.message);
            router.push("/");
        });
    });

    onUnmounted(() => {
        if (cockpitHidingTimeoutId) {
            clearTimeout(cockpitHidingTimeoutId);
            cockpitHidingTimeoutId = null;
        }
        if (statisticsLoggerId.value) {
            clearInterval(statisticsLoggerId.value);
            statisticsLoggerId.value = null;
        }
        if (session != null) {
            MindSDK.exit2(session);
            session = null;
        }
    });

</script>

<style scoped>

    .view {
        width: 100%;
        height: 100%;

        display: flex;
        flex-direction: row;

        background: #000;
        color: #fff;
    }

    #center {
        position: relative;
        flex: 1;
        height: 100%;
    }

    #conference-name {
        position: absolute;
        top: 5px;
        left: 5px;
        padding: 5px 10px;
        font-size: 1em;
        background: #212121;
    }

    #chat {
        height: 100%;
        width: 450px;
    }

    #cockpit {
        position: absolute;
        bottom: 100px;
        left: 50%;
        transform: translateX(-50%);
        height: auto;
        width: auto;
        z-index: 2;
        display: block;
        transition: opacity 500ms, visibility 500ms;
        transition-delay: 500ms;
        opacity: 0;
        visibility: collapse;
    }

    .view.show-cockpit #cockpit {
        transition: opacity 0s, visibility 0s;
        transition-delay: 0ms;
        opacity: 1;
        visibility: visible;
    }

</style>